#include <stdio.h>
#include <string.h>
#include "global.h"
#include "db.h"

FILE* errlog;
#undef ERRLOG
int sigil(char* req){

  char buf[1024];
  U32 idx = sigil_idx(req);
  int ret =  idx_URL(idx,buf);
 if(ret) {
    printf("[%s](@%X) %s\n",req,idx*4,buf);
    return 0;
  } else {
    printf("Not Found\n");
    return 1;
  }
}

int url(char* url){
  printf("[%s]\n",url);
  U32 idx = URL_check(url);
  if(idx){
    char sigil[5];
    idx_sigil(idx,sigil);
    printf("%s\n",sigil);
    return 0;
  } else {
    printf("Not Found\n");
    return 1;
  }
}

  
int main(int argc,char*argv[]){
  if(argc>2) {
    printf("Usage: lookup XXXX<enter>, where XXXX is a 4-char sigil\n");
    printf("   or  lookup <url><enter>\n");
    return 1;
  }
  int ret; 
  sys_open();
  if(4==strlen(argv[1])) {
    ret = sigil(argv[1]);
  } else {
    ret = url(argv[1]);
  }
  sys_close();
  return ret;
}

